> ## Documentation Index
> Fetch the complete documentation index at: https://api.corpay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get transactions for a card

> Retrieve transactions for a single card with filters and pagination.
ProductIds identifies the Products from the Corpay System.
Note: after a user stopped the session, a transaction might take up to 10 minutes to be available via the transactions endpoints.


**Performance expectations:**<br />
**p50:** 250 ms, **p99:** 1500 ms.<br />
Measured on successful requests (2xx), server-side only.<br />
[How to interpret these metrics](/performance)


## OpenAPI

````yaml /openapi.yaml post /cards/{cardIdentifier}/transactions
openapi: 3.1.0
info:
  title: Corpay APIs
  version: 1.0.0
  description: >
    Corpay APIs for customer profile management, card management, transaction
    history, and master data retrieval.
servers:
  - url: https://apigwuat.corpay.com
    description: Test environment
  - url: https://apigw.corpay.com
    description: Production environment
security:
  - oauth2ClientCredentials: []
tags:
  - name: Customer
    description: Customer profile and account lifecycle APIs
  - name: Card
    description: Card retrieval, ordering and lifecycle APIs
  - name: Geosearch
    description: >-
      Search and retrieve detailed information about charging locations and
      stations
  - name: Remote Charging
    description: >-
      Control charging sessions remotely including starting and stopping
      sessions, and monitoring session status
  - name: EV Session
    description: >-
      Access and manage charging session data including history, status, and
      detailed session information
  - name: Transaction
    description: Transaction history APIs
  - name: Master
    description: Master/reference data APIs
  - name: Webhooks
    description: Event callback payloads sent by Corpay
paths:
  /cards/{cardIdentifier}/transactions:
    post:
      tags:
        - Transaction
      summary: Get transactions for a card
      description: >
        Retrieve transactions for a single card with filters and pagination.

        ProductIds identifies the Products from the Corpay System.

        Note: after a user stopped the session, a transaction might take up to
        10 minutes to be available via the transactions endpoints.
      operationId: getCardTransactions
      parameters:
        - name: cardIdentifier
          in: path
          required: true
          schema:
            type: integer
      requestBody:
        required: false
        content:
          application/json:
            schema:
              type: object
              properties:
                transactionDateFrom:
                  type: string
                  format: date
                transactionDateTo:
                  type: string
                  format: date
                billingStatus:
                  type: string
                  enum:
                    - Billed
                    - Unbilled
                    - All
                productIds:
                  type: array
                  items:
                    type: integer
                cursor:
                  type: string
                limit:
                  type: integer
                sortExpression:
                  type: string
      responses:
        '200':
          description: Transactions
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionsResponse'
              example:
                $ref: '#/components/schemas/TransactionsResponse/example'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/Forbidden'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/InternalServerError'
components:
  schemas:
    TransactionsResponse:
      example:
        hasNextPage: true
        nextCursor: '454334'
        totalCount: 120
        transactions:
          - cardGroupId: 43534
            cardGroupName: Fleet Group A
            cardIdentifier: 453
            cardNumber: 411111******1111
            currency: EUR
            customerAccountNumber: '435435'
            duration: 45
            evEndTime: '2025-01-15T11:00:00.000Z'
            evStartTime: '2025-01-15T10:15:00.000Z'
            homeChargeVatExempt: false
            keyIdentifier: '23221321'
            merchant:
              address:
                addressLines: 123 Energy Park
                city: Amsterdam
                country: Netherlands
                countryCode: NLD
                region: North Holland
                zipCode: '12345'
              incomingMerchantDescription: FastCharge NL Central
              incomingMerchantNumber: IM-7890
              merchantId: 223
              merchantName: FastCharge Station
            merchantGroup:
              merchantGroupId: 324
              merchantGroupName: FastCharge Group
            network:
              networkId: 2342
              networkName: IONITY
            odometer: 45230
            powerType: DC
            private: false
            productGroup:
              productGroupId: 234
              productGroupName: EV Charging
            totalAmountExclVAT: 125.63
            totalAmountInclVAT: 150.75
            transactionDate: '2025-01-15T00:00:00.000Z'
            transactionId: 2332-2322-3322-1212
            voucherNumber: zmdkwl33
            transactionSegments:
              - product:
                  productCode: EV-DC-FAST
                  productId: 501
                  productName: DC Fast Charging
                productEndTime: '2025-01-15T10:40:00.000Z'
                productQuantity: 20.5
                productStartTime: '2025-01-15T10:15:00.000Z'
                transactionLineItemId: 1
                unitAmountExclVAT: 62.82
              - product:
                  productCode: EV-AC
                  productId: 502
                  productName: AC Charging
                productEndTime: '2025-01-15T11:00:00.000Z'
                productQuantity: 18.3
                productStartTime: '2025-01-15T10:40:00.000Z'
                transactionLineItemId: 2
                unitAmountExclVAT: 62.81
                unitAmountInclVAT: 75.37
            transactionStatus: Unbilled
            vatRate: 20%
            vehicleRegistrationNumber: AB12CDE
      properties:
        hasNextPage:
          type: boolean
        lastPage:
          type: boolean
        nextCursor:
          type: string
        totalCount:
          type: integer
        transactions:
          items:
            $ref: '#/components/schemas/Transaction'
          type: array
      type: object
    Transaction:
      properties:
        cardGroupId:
          type: integer
        cardGroupName:
          type: string
        cardIdentifier:
          type: integer
        cardNumber:
          type: string
        currency:
          type: string
        customerAccountNumber:
          type: string
        duration:
          type: time
        evEndTime:
          type: datetime
        evStartTime:
          type: datetime
        homeChargeVatExempt:
          type: boolean
        keyIdentifier:
          type: string
        merchant:
          properties:
            address:
              properties:
                addressLines:
                  type: string
                city:
                  type: string
                country:
                  type: string
                countryCode:
                  type: string
                region:
                  type: string
                zipcode:
                  type: string
              type: object
            incomingMerchantDescription:
              type: string
            incomingMerchantNumber:
              type: string
            merchantId:
              type: integer
            merchantName:
              type: string
          type: object
        merchantGroup:
          properties:
            merchantGroupId:
              type: integer
            merchantGroupName:
              type: string
          type: object
        network:
          properties:
            networkId:
              type: integer
            networkName:
              type: string
          type: object
        odometer:
          type: integer
        powerType:
          type: string
        private:
          type: boolean
        productGroup:
          properties:
            productGroupId:
              type: integer
            productGroupName:
              type: string
          type: object
        totalAmountExclVAT:
          type: decimal
        totalAmountInclVAT:
          type: decimal
        transactionDate:
          type: date
        transactionId:
          type: string
        voucherNumber:
          type: string
        transactionSegments:
          items:
            properties:
              product:
                properties:
                  productCode:
                    type: string
                  productId:
                    type: integer
                  productName:
                    type: string
                type: object
              productEndTime:
                type: datetime
              productQuantity:
                type: decimal
              productStartTime:
                type: datetime
              transactionLineItemId:
                type: integer
              unitAmountExclVAT:
                type: decimal
            type: object
          type: array
        transactionStatus:
          type: string
        vatRate:
          type: decimal
        vehicleRegistrationNumber:
          type: string
      type: object
    Error:
      example:
        errorCode: ER-001
        errorDescription: Invalid request parameters
      properties:
        errorCode:
          type: string
        errorDescription:
          type: string
      required:
        - errorCode
        - errorDescription
      type: object
  responses:
    BadRequest:
      content:
        application/json:
          example:
            errorCode: ER-001
            errorDescription: Invalid request parameters
          schema:
            $ref: '#/components/schemas/Error'
      description: Bad request - validation error
    Unauthorized:
      description: Unauthorized - missing or invalid authentication token
    Forbidden:
      description: Forbidden - insufficient permissions
    NotFound:
      description: Not found - resource does not exist
    InternalServerError:
      content:
        application/json:
          example:
            errorCode: ER-012
            errorDescription: >-
              The server encountered an unexpected condition and could not
              complete the request. Please contact Corpay Support.
          schema:
            $ref: '#/components/schemas/Error'
      description: Internal server error
  securitySchemes:
    oauth2ClientCredentials:
      description: >
        Use OAuth2 client credentials to obtain a bearer token.


        Token endpoint:

        `POST <BASE_URL>/keycloak/realms/longship/protocol/openid-connect/token`


        Use the same base URL as the selected API server:

        - Test environment: `https://apigwuat.corpay.com`

        - Production environment: `https://apigw.corpay.com`


        Example:

        ```bash

        curl --location
        '<BASE_URL>/keycloak/realms/longship/protocol/openid-connect/token' \

        --header 'accept: application/json' \

        --data-urlencode 'grant_type=client_credentials' \

        --data-urlencode 'client_id=.......' \

        --data-urlencode 'client_secret=......'

        ```
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /keycloak/realms/longship/protocol/openid-connect/token
      type: oauth2

````